\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{bm}
\usepackage{mathtools}

\newcommand{\vsum}[1]{%
  \sideset{}{_{#1}}\sum
}
\newcommand{\vprod}[1]{%
  \sideset{}{_{#1}}\prod
}

\begin{document}

\begin{equation}
\bm{s}^{(t)}=f(\bm{s}^{(t-1)};\bm{\theta}) \tag{10.1}
\end{equation}

\begin{equation}
\bm{s}^{(3)}=f(\bm{s}^{(2)};\bm{\theta}) \tag{10.2}
\end{equation}

\begin{equation}
=f(f(\bm{s}^{(1)};\bm{\theta});\bm{\theta}) \tag{10.3}
\end{equation}

\begin{equation}
\bm{s}^{(t)}=f(\bm{s}^{(t-1)},\bm{x}^{(t)};\bm{\theta}) \tag{10.4}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=f(\bm{h}^{(t-1)},\bm{x}^{(t)};\bm{\theta}) \tag{10.5}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=g^{(t)}(\bm{x}^{(t)},\bm{x}^{(t-1)},\bm{x}^{(t-2)},...,\bm{x}^{(2)},\bm{x}^{(1)}) \tag{10.6}
\end{equation}

\begin{equation}
=f(\bm{h}^{(t-1)},\bm{x}^{(t)};\bm{\theta}) \tag{10.7}
\end{equation}

\begin{equation}
\bm{a}^{(t)}= \bm{b}+\bm{W}\bm{h}^{(t+1)}+\bm{U}\bm{x}^{(t)}\tag{10.8}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=\mathrm{tanh}(\bm{a}^{(t)})\tag{10.9}
\end{equation}

\begin{equation}
\bm{o}^{(t)}=\bm{c}+\bm{V}\bm{h}^{(t)}\tag{10.10}
\end{equation}

\begin{equation}
\hat{\bm{y}}^{(t)}=\mathrm{softmax}(\bm{o}^{(t)})\tag{10.11}
\end{equation}

\begin{equation}
L\Big(\{\bm{x}^{(1)},...,\bm{x}^{(\tau)}\},\{\bm{y}^{(1)},...,\bm{y}^{(\tau)}\}\Big)\tag{10.12}
\end{equation}

\begin{equation}
\sum_{t}L^{(t)}\tag{10.13}
\end{equation}

\begin{equation}
=-\sum_{t}\mathrm{log}p_{\mathrm{model}}\Big(\bm{y}^{(t)}|\{\bm{x}^{(1)},...,\bm{x}^{(t)}\}\Big)\tag{10.14}
\end{equation}

\begin{equation}
\mathrm{log}p\Big(\bm{y}^{(1)},\bm{y}^{(2)}|\bm{x}^{(1)},\bm{x}^{(2)}\Big)\tag{10.15}
\end{equation}

\begin{equation}
=\mathrm{log}p\Big(\bm{y}^{(2)}|\bm{y}^{(1)},\bm{x}^{(1)},\bm{x}^{(2)}\Big)+\mathrm{log}p\Big(\bm{y}^{(1)}|\bm{x}^{(1)},\bm{x}^{(2)}\Big)\tag{10.16}
\end{equation}

\begin{equation}
\frac{\partial L}{\partial L^{(t)}}=1\tag{10.17}
\end{equation}

\begin{equation}
\big(\nabla_{\bm{o}^{(t)}}L\big)_{i}=\frac{\partial L}{\partial o^{(t)}_{i}}=\frac{\partial L}{\partial L^{(t)}}\frac{\partial L^{(t)}}{\partial o^{(t)}_{i}}=\hat{y}^{(t)}_{i}-\bm{1}_{i,y^{(t)}}\tag{10.18}
\end{equation}

\begin{equation}
\nabla_{\bm{h}^{(\tau)}}L=\bm{V}^{\top}\nabla_{\bm{o}^{(\tau)}}L\tag{10.19}
\end{equation}

\begin{equation}
\nabla_{\bm{h}^{(t)}}L=\Bigg(\frac{\partial \bm{h}^{(t+1)}}{\partial \bm{h}^{(t)}}\Bigg)^{\top} \\ (\nabla_{\bm{h}^{(t+1)}}L)+\Bigg(\frac{\partial \bm{o}^{(t)}}{\partial \bm{h}^{(t)}}\Bigg)^{\top}\\(\nabla_{\bm{o}^{(t)}}L)\tag{10.20}
\end{equation}

\begin{equation}
=\bm{W}^{\top}(\nabla_{\bm{h}^{(t+1)}}L)\mathrm{diag}\bigg(1-\Big(\bm{h}^{(t+1)}\Big)^{2}\bigg)+\bm{V}^{\top}(\nabla_{\bm{o}^{(t)}}L)\tag{10.21}
\end{equation}

\begin{equation}
\nabla_{\bm{c}}L=\sum_{t}\Bigg(\frac{\partial \bm{o}^{(t)}}{\partial \bm{c}}\Bigg)^{\top} \\\nabla_{\bm{o}^{(t)}}L=\sum_{t}\nabla_{\bm{o}^{(t)}}L \tag{10.22}
\end{equation}

\begin{equation}
\nabla_{\bm{b}}L=\sum_{t}\Bigg(\frac{\partial \bm{h}^{(t)}}{\partial \bm{b}^{(t)}}\Bigg)^{\top} \\\nabla_{\bm{h}^{(t)}}L=\sum_{t}\mathrm{diag}\bigg(1-\Big(\bm{h}^{(t)}\Big)^{2}\bigg)\nabla_{\bm{h}^{(t)}}L \tag{10.23}
\end{equation}

\begin{equation}
\nabla_{\bm{V}}L=\sum_{t}\sum_{i}\Bigg(\frac{\partial L}{\partial o^{(t)}_{i}}\Bigg)\nabla_{\bm{V}}o^{(t)}_{i}=\sum_{t}(\nabla_{\bm{o}^{(t)}}L)\bm{h}^{(t)^{\top}} \tag{10.24}
\end{equation}

\begin{equation}
\nabla_{\bm{W}}L=\sum_{t}\sum_{i}\Bigg(\frac{\partial L}{\partial h^{(t)}_{i}}\Bigg)\nabla_{\bm{W}}h^{(t)}_{i}\tag{10.25}
\end{equation}

\begin{equation}
=\sum_{t}\mathrm{diag}\bigg(1-\Big(\bm{h}^{(t)}\Big)^{2}\bigg)(\nabla_{\bm{h}^{(t)}}L)\bm{h}^{(t-1)^{\top}} \tag{10.26}
\end{equation}

\begin{equation}
\nabla_{\bm{U}}L=\sum_{t}\sum_{i}\Bigg(\frac{\partial L}{\partial h^{(t)}_{i}}\Bigg)\nabla_{\bm{U}^{(t)}}h^{(t)}_{i}\tag{10.27}
\end{equation}

\begin{equation}
=\sum_{t}\mathrm{diag}\bigg(1-\Big(\bm{h}^{(t)}\Big)^{2}\bigg)(\nabla_{\bm{h}^{(t)}}L)\bm{x}^{(t)^{\top}} \tag{10.28}
\end{equation}

\begin{equation}
\mathrm{log}p(\bm{y}^{(t)}|\bm{x}^{(1)},...,\bm{x}^{(t)})\tag{10.29}
\end{equation}

\begin{equation}
\mathrm{log}p(\bm{y}^{(t)}|\bm{x}^{(1)},...,\bm{x}^{(t)},\bm{y}^{(1)},...,\bm{y}^{(t-1)})\tag{10.30}
\end{equation}

\begin{equation}
P(\mathbb{Y})=P(\bm{\mathrm{y}}^{(1)},...,\bm{\mathrm{y}}^{(\tau)})=\prod_{t=1}^{\tau}P(\bm{\mathrm{y}}^{(t)}|\bm{\mathrm{y}}^{(t-1)},\bm{\mathrm{y}}^{(t-2)}...,\bm{\mathrm{y}}^{(1)})\tag{10.31}
\end{equation}

\begin{equation}
L=\sum_{t}L^{(t)}\tag{10.32}
\end{equation}

\begin{equation}
L^{(t)}=-\mathrm{log}P(\mathrm{y}^{(t)}=y^{(t)}|y^{(t-1)},y^{(t-2)}...,y^{(1)})\tag{10.33}
\end{equation}

\begin{equation}
P(\bm{x}^{(1)},...,\bm{x}^{(\tau)}=P(\tau)P(\bm{x}^{(1)},...,\bm{x}^{(\tau)}|\tau)\tag{10.34}
\end{equation}

\begin{equation}
\prod_{t}P(\bm{y}^{(t)}|\bm{x}^{(1)},...,\bm{x}^{(t)})\tag{10.35}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=\bm{W}^{\top}\bm{h}^{(t-1)}\tag{10.36}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=(\bm{W}^{t})^{\top}\bm{h}^{(0)}\tag{10.37}
\end{equation}

\begin{equation}
\bm{W}=\bm{Q}\bm{\Lambda}\bm{Q}^{\top}\tag{10.38}
\end{equation}

\begin{equation}
\bm{h}^{(t)}=\bm{Q}^{\top}\bm{\Lambda}^{t}\bm{Q}\bm{h}^{(0)}\tag{10.39}
\end{equation}

\begin{equation}
f_{i}^{(t)}=\sigma\Bigg(b_{i}^{f}+\sum_{j}U_{i,j}^{f}x_{j}^{(t)}+\sum_{j}W_{i,j}^{f}h_{j}^{(t-1)}\Bigg)\tag{10.40}
\end{equation}

\begin{equation}
s_{i}^{(t)}=f_{i}^{(t)}s_{i}^{(t-1)}+g_{i}^{(t)}\sigma\Bigg(b_{i}+\sum_{j}U_{i,j}x_{j}^{(t)}+\sum_{j}W_{i,j}h_{j}^{(t-1)}\Bigg)\tag{10.41}
\end{equation}

\begin{equation}
g_{i}^{(t)}=\sigma\Bigg(b_{i}^{g}+\sum_{j}U_{i,j}^{g}x_{j}^{(t)}+\sum_{j}W_{i,j}^{g}h_{j}^{(t-1)}\Bigg)\tag{10.42}
\end{equation}

\begin{equation}
h_{i}^{(t)}=\mathrm{tanh}\Big(s_{i}^{(t)}\Big)q_{i}^{(t)}\tag{10.43}
\end{equation}

\begin{equation}
q_{i}^{(t)}=\sigma\Bigg(b_{i}^{o}+\sum_{j}U_{i,j}^{o}x_{j}^{(t)}+\sum_{j}W_{i,j}^{o}h_{j}^{(t-1)}\Bigg)\tag{10.44}
\end{equation}

\begin{equation}
h_{i}^{(t)}=u_{i}^{(t-1)}h_{i}^{(t-1)}+(1-u_{i}^{(t-1)})\sigma\Bigg(b_{i}+\sum_{j}U_{i,j}x_{j}^{(t-1)}+\sum_{j}W_{i,j}r_{j}^{(t-1)}h_{j}^{(t-1)}\Bigg)\tag{10.45}
\end{equation}

\begin{equation}
u_{i}^{(t)}=\sigma\Bigg(b_{i}^{u}+\sum_{j}U_{i,j}^{u}x_{j}^{(t)}+\sum_{j}W_{i,j}^{u}h_{j}^{(t)}\Bigg)\tag{10.46}
\end{equation}

\begin{equation}
r_{i}^{(t)}=\sigma\Bigg(b_{i}^{r}+\sum_{j}U_{i,j}^{r}x_{j}^{(t)}+\sum_{j}W_{i,j}^{r}h_{j}^{(t)}\Bigg)\tag{10.47}
\end{equation}

\begin{equation}
\mathrm{if}\|\bm{g}\|>v\tag{10.48}
\end{equation}

\begin{equation}
\bm{g}\leftarrow \frac{\bm{g}v}{\|\bm{g}\|}\tag{10.49}
\end{equation}

\begin{equation}
(\nabla_{\bm{h}^{(t)}}L)\frac{\partial \bm{h}^{(t)}}{\partial \bm{h}^(t-1)}\tag{10.50}
\end{equation}

\begin{equation}
\nabla_{\bm{h}^{(t)}}L\tag{10.51}
\end{equation}

\begin{equation}
\Omega=\sum_{t}\Bigg(\frac{\bigg|\big|(\nabla_{\bm{h}^{(t)}}L)\frac{\partial \bm{h}^{(t)}}{\partial \bm{h}^(t-1)}\bigg|\big|}{||\nabla_{\bm{h}^{(t)}}L||}-1\Bigg)^{2}\tag{10.52}
\end{equation}

\begin{equation}

\end{equation}

\begin{equation}

\end{equation}

\begin{equation}

\end{equation}

\begin{equation}

\end{equation}

\begin{equation}

\end{equation}

\begin{equation}

\end{equation}


\end{document}








